// includes + defines {{{
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <complex>
#define REP(i, n) for(int i = 0; i < (int)(n); ++i)
#define FOR(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i)
#define FORD(i, a, b) for(int i = (int)(a); i >= (int)(b); --i)
#define FORE(it, c) for(__typeof((c).begin()) it = (c).begin(); it != (c).end(); ++it)
#define SIZE(x) ((int)((x).size()))
#define DEBUG(x) { cout << #x << ": " << (x) << endl; }
#define SQR(x) ((x) * (x))
#define INF 1023456789
using namespace std;
// }}}

vector<vector<int> > G, T;
vector<bool> V;
vector<int> S;
int cnt = 0;

void DFS(int x){
	V[x] = true;

	FORE(i, G[x])
		if(!V[*i])
			DFS(*i);

	S.push_back(x);
}

vector<bool> B;
vector<int> C, P;
int act;

void DFS2(int x){
	C[x] = act;
	++P[act];

	FORE(i, T[x])
		if(C[*i] == -1)
			DFS2(*i);
		else if(C[*i] != act)
			B[C[*i]] = false;
}

int main(){
	int N, M;
	scanf("%d %d", &N, &M);
	G.resize(N);
	T.resize(N);
	while(M--){
		int a, b;
		scanf("%d %d", &a, &b);
		--a, --b;
		G[a].push_back(b);
		T[b].push_back(a);
	}

	V.resize(N, false);
	REP(i, N)
		if(!V[i])
			DFS(i);

	B.resize(N, true);
	C.resize(N, -1);
	P.resize(N, 0);
	FORD(i, N - 1, 0)
		if(C[S[i]] == -1){
			act = S[i];
			DFS2(S[i]);
		}

	int res = N;
	REP(i, N)
		if(B[C[i]])
			res = min(res, P[C[i]]);
	printf("%d\n", res);
}
